# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Peering::Mgmt::V2019_08_01_preview
  module Models
    #
    # The properties that define an exchange peering facility.
    #
    class ExchangePeeringFacility

      include MsRestAzure

      # @return [String] The name of the exchange peering facility.
      attr_accessor :exchange_name

      # @return [Integer] The bandwidth of the connection between Microsoft and
      # the exchange peering facility.
      attr_accessor :bandwidth_in_mbps

      # @return [String] The IPv4 address of Microsoft at the exchange peering
      # facility.
      attr_accessor :microsoft_ipv4address

      # @return [String] The IPv6 address of Microsoft at the exchange peering
      # facility.
      attr_accessor :microsoft_ipv6address

      # @return [String] The IPv4 prefixes associated with the exchange peering
      # facility.
      attr_accessor :facility_ipv4prefix

      # @return [String] The IPv6 prefixes associated with the exchange peering
      # facility.
      attr_accessor :facility_ipv6prefix

      # @return [Integer] The PeeringDB.com ID of the facility.
      attr_accessor :peering_dbfacility_id

      # @return [String] The PeeringDB.com URL of the facility.
      attr_accessor :peering_dbfacility_link


      #
      # Mapper for ExchangePeeringFacility class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ExchangePeeringFacility',
          type: {
            name: 'Composite',
            class_name: 'ExchangePeeringFacility',
            model_properties: {
              exchange_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'exchangeName',
                type: {
                  name: 'String'
                }
              },
              bandwidth_in_mbps: {
                client_side_validation: true,
                required: false,
                serialized_name: 'bandwidthInMbps',
                type: {
                  name: 'Number'
                }
              },
              microsoft_ipv4address: {
                client_side_validation: true,
                required: false,
                serialized_name: 'microsoftIPv4Address',
                type: {
                  name: 'String'
                }
              },
              microsoft_ipv6address: {
                client_side_validation: true,
                required: false,
                serialized_name: 'microsoftIPv6Address',
                type: {
                  name: 'String'
                }
              },
              facility_ipv4prefix: {
                client_side_validation: true,
                required: false,
                serialized_name: 'facilityIPv4Prefix',
                type: {
                  name: 'String'
                }
              },
              facility_ipv6prefix: {
                client_side_validation: true,
                required: false,
                serialized_name: 'facilityIPv6Prefix',
                type: {
                  name: 'String'
                }
              },
              peering_dbfacility_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'peeringDBFacilityId',
                type: {
                  name: 'Number'
                }
              },
              peering_dbfacility_link: {
                client_side_validation: true,
                required: false,
                serialized_name: 'peeringDBFacilityLink',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
